#include "main.h"
#include "schedule.h"

// LED 1: 3 sec an, 3sec aus, 3sec an, 3sec aus usw.


void LED0_on( void )
{
  LED_PORT &= ~(1<<LED0);
}

void LED0_off( void )
{
  LED_PORT |= (1<<LED0);
}

void LED0_flasher( void )
{
  LED0_on();
  timeradd( LED0_flasher, SECONDS( 3 + 3 ));	// repeat itself
  timeradd( LED0_off,     SECONDS( 3 ));
}


// LED 2: 2 an, 2 aus, 2 an, 5 aus, 5 an, 10 aus  (immer wiederholt)

void LED1_on( void )
{
  LED_PORT &= ~(1<<LED1);
}

void LED1_off( void )
{
  LED_PORT |= (1<<LED1);
}

void LED1_flasher( void )
{
  LED1_on();
  timeradd( LED1_flasher, SECONDS( 2 + 2 + 2 + 5 + 5 + 10 ));	// repeat itself
  timeradd( LED1_off,     SECONDS( 2 ));
  timeradd( LED1_on,      SECONDS( 2 + 2 ));
  timeradd( LED1_off,     SECONDS( 2 + 2 + 2 ));
  timeradd( LED1_on,      SECONDS( 2 + 2 + 2 + 5 ));
  timeradd( LED1_off,     SECONDS( 2 + 2 + 2 + 5 + 5 ));
}


// LED 3: 10 an, 1 aus, 2 an, 1 aus (immer wiederholt)"

void LED2_on( void )
{
  LED_PORT &= ~(1<<LED2);
}

void LED2_off( void )
{
  LED_PORT |= (1<<LED2);
}

void LED2_flasher( void )
{
  LED2_on();
  timeradd( LED2_flasher, SECONDS( 10 + 1 + 2 + 1 ));	// repeat itself
  timeradd( LED2_off,     SECONDS( 10 ));
  timeradd( LED2_on,      SECONDS( 10 + 1 ));
  timeradd( LED2_off,     SECONDS( 10 + 1 + 2 ));
}


int main(void)
{
  TCCR0 = 1<<CS01^1<<CS00;			// divide by 64 * 256

  LED_DDR = 0xFF;
  LED_PORT = 0xFF;

  timerinit();
  LED0_flasher();
  LED1_flasher();
  LED2_flasher();

  for(;;){					// main loop
    if( TIFR & 1<<TOV0 ){
      TIFR = 1<<TOV0;
      timertick();
    }
  }
}
